var premiumproxyswitcher = {
	enabled: false,
	loading: false,
	proxies: new Array(),
	selectedProxy: null,
	rebuildProxyMenuList: true,
	serviceurl: 'http://freeproxylist.org/en/firefox-addon.php',
	serverporturl: 'http://freeproxylist.org/en/countryportlist.php?nojson=',
	countryflagsurl: 'http://freeproxylist.org/en/countryflags.php',
	prefManager: null,
	
	proxystatechecker: null,
	autodownloadinterval: null,
	autochangeinterval: null,
	loadingproxylist: false,
	propertiesBundle: null,

  onLoad: function() {
	this.prefManager = Components.classes["@mozilla.org/preferences-service;1"]
								 .getService(Components.interfaces.nsIPrefBranch);
  
    // initialization code
    this.initialized = true;
	
	var proxytype = this.prefManager.getIntPref("network.proxy.type");
	var initserver = this.prefManager.getCharPref("network.proxy.http");
	var initport = this.prefManager.getIntPref("network.proxy.http_port");
	if(initserver != null && initserver != ''){
		this.selectedProxy = {cc: '??', cn: "Unknown country", server: initserver, port: initport};
	}
	
	this.switchMode(proxytype > 0);
	this.onUpdateConfiguration(true);
	this.loadServerPortOptions();
	
	var instance = this;
	var event = { notify: function(){
		if(instance.loadingproxylist == true){
			return;
		}
		
		var proxytype = instance.prefManager.getIntPref("network.proxy.type");
		if(proxytype == 0){
			instance.switchMode(false);
		}else{
			instance.switchMode(true);
		}
		}}
	this.proxystatechecker = Components.classes["@mozilla.org/timer;1"]
									   .createInstance(Components.interfaces.nsITimer);
	this.proxystatechecker.initWithCallback(event, 300, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
	
	this.$('premiumproxyswitcher-status-image').addEventListener('click', function(event){
		if(event.button == 0){
			instance.toggleProxy();
			}
		}, false);
	
	this.$('premiumproxyswitcher-status-label').addEventListener('click', function(event){
		if(event.button == 0){
			instance.toggleProxy();
			}
		}, false);
  },
  
  onUpdateConfiguration: function(init){
	init = (init == null) ? false : init;
	var instance = this;
  
	var auto = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optauto');
	if(this.autodownloadinterval != null){
		this.autodownloadinterval.cancel();
		this.autodownloadinterval = null;
	}
	
	var timeout = this.prefManager.getIntPref('extensions.premiumproxyswitcher.optinterval');
	if(auto && timeout > 0){
		var event = { notify: function() {instance.loadProxyServers();} }
		this.autodownloadinterval = Components.classes["@mozilla.org/timer;1"]
											  .createInstance(Components.interfaces.nsITimer);
		this.autodownloadinterval.initWithCallback(event, timeout*60*1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
	}
	
	this.loadProxyServers(init);
  
	auto = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optautochange');
	if(this.autochangeinterval != null){
		this.autochangeinterval.cancel();
		this.autochangeinterval = null;
	}
	
	timeout = this.prefManager.getIntPref('extensions.premiumproxyswitcher.optintervalchange');
	if(auto && timeout > 0){
		var event = { notify: function(){instance.switchProxyServer();} }
		this.autochangeinterval = Components.classes["@mozilla.org/timer;1"]
											.createInstance(Components.interfaces.nsITimer);
		this.autochangeinterval.initWithCallback(event, timeout*60*1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
	}
  },
  
  getPropertyString: function(name){
	try{
		if (this.propertiesBundle == null){
			var oBundle	= Components.classes['@mozilla.org/intl/stringbundle;1']
									.getService(Components.interfaces.nsIStringBundleService);
			this.propertiesBundle = oBundle.createBundle('chrome://premiumproxyswitcher/locale/premiumproxyswitcher.properties');
		}
		return this.propertiesBundle.GetStringFromName(name);
	}catch(err){}
	
	return name;
  }
}

premiumproxyswitcher.loadServerPortOptions = function(){
	var originaltype = this.prefManager.getIntPref("network.proxy.type");
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	var request = new XMLHttpRequest();
	request.open("GET", this.serverporturl, true);
	
	var instance = this;
	request.onreadystatechange = function(){
		if ( request.readyState == 2 ) {
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if ( request.readyState == 4 ) {
			if ( request.status == 200 ) {
				var showPreferences = instance.prefManager.getBoolPref('extensions.premiumproxyswitcher.showpreferences');
				if (showPreferences) {
					instance.openOptionDialog();
					instance.prefManager.setBoolPref('extensions.premiumproxyswitcher.showpreferences', false);
				}
				var text = request.responseText;
				instance.prefManager.setCharPref('extensions.premiumproxyswitcher.serverportoptions', text);
			}
		}
	}
	
	request.send({});
}

premiumproxyswitcher.updateCountryFlags = function(){
	var originaltype = this.prefManager.getIntPref("network.proxy.type");
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	this.loading = true;
	this.updateStatusBar();

	var request = new XMLHttpRequest();
	var params = [];
	var proxyList = new Array();
	for(var i in this.proxies){
		var proxy = this.proxies[i];
		proxyList.push(proxy.server+':'+proxy.port);
	}
	proxyListString = proxyList.join("\r\n")
	params.push('proxylist='+proxyListString);
	params = params.join('&');
	
	request.open("POST", this.countryflagsurl, true);
	request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	request.setRequestHeader("Content-length", params.length);
	request.setRequestHeader("Connection", "close");
	
	var instance = this;
	request.onreadystatechange = function(){
		if ( request.readyState == 2 ) {
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if ( request.readyState == 4 ) {
			instance.loading = false;
			instance.updateStatusBar();
			if ( request.status == 200 ) {
				var text = request.responseText;
				instance.loadProxyList(text);
			}
		}
	}
	
	request.send(params);
}

premiumproxyswitcher.fetchProxyList = function(url, postfield){
	//var ioService = Components.classes["@mozilla.org/network/io-service;1"]  
    //                      .getService(Components.interfaces.nsIIOService); 
	//var uri = ioService.newURI(myURLString, null, null);
	
	if(url == null) {
		this.loadProxyListFromCache();
		return;
	}
	
	if(url == null || url == ''){
		alert(this.getPropertyString('wrongUrl'));
		return;
	}
	
	this.loadingproxylist = true;
	this.loading = true;
	this.updateStatusBar();
	var request = new XMLHttpRequest();
	var params = {};
	
	var originaltype = this.prefManager.getIntPref("network.proxy.type");
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	var updateCountryFlag = false;
	if(postfield != null){
		params = [];
		for(var i in postfield){
			params.push(i+'='+postfield[i]);
		}
		params = params.join('&');
		request.open("POST", url, true);
		request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		request.setRequestHeader("Content-length", params.length);
		request.setRequestHeader("Connection", "close");
	}else{
		request.open("GET", url, true);
		updateCountryFlag = true;
	}
	
	var instance = this;
	request.onreadystatechange = function(){
		if(request.readyState == 2){
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if (request.readyState == 4) {
			instance.loading = false;
			instance.updateStatusBar();
			instance.loadingproxylist = false;
			if (request.status == 200) {
				var text = request.responseText;
				if(text.indexOf('ERROR:') == 0){
					alert(text);
					return;
				}
				
				instance.loadProxyList(text);
				if (updateCountryFlag)
					instance.updateCountryFlags();
				if(instance.selectedProxy == null)
					instance.switchProxyServer(null, false);
			}else{
				alert(instance.getPropertyString('proxyLoadFaild'));
			}
		}
	}
	
	request.send(params);
}

premiumproxyswitcher.toggleProxy = function(event){
	var proxytype = this.prefManager.getIntPref("network.proxy.type");
	if(proxytype == 0){
		if(this.proxies.length > 0){
			this.switchMode(true);
			this.prefManager.setIntPref("network.proxy.type", 1);
			this.switchProxyServer(null, false);
		}
	}else{
		this.switchMode(false);
		this.prefManager.setIntPref("network.proxy.type", 0);
	}
}

premiumproxyswitcher.loadProxyList = function(text){
	var lines = text.split('\n');
	this.proxies.splice(0, this.proxies.length);
	
	var matches = text.match(/\w{2}\|[^\|]+\|(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):(\d{1,5})/g);
	if (matches != null) {
		for(var i in matches){
			var rawMatch = matches[i].split('|');
			var match = rawMatch[2];
			var pos = match.indexOf(':');
			if(pos > 0){
				var proxy = {};
				proxy.cc = rawMatch[0];
				proxy.cn = rawMatch[1];
				proxy.server = match.substring(0, pos);
				proxy.port = parseInt(match.substring(pos+1));
				this.proxies.push(proxy);
			}
		}
	} else {
		var matches = text.match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}[^\d]+\d{1,5}/g);
		for(var i in matches){
			var server = matches[i].match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/);
			var port = matches[i].match(/\d{1,5}$/);
			if (server !== null && port !== null) {
				var proxy = {};
				proxy.cc = '??';
				proxy.cn = 'Unknown country';
				proxy.server = server;
				proxy.port = port;
				this.proxies.push(proxy);
			}
		}
	}
	
	if(this.proxies.length == 0){
		alert(this.getPropertyString('noProxyFound'));
	} else {
		this.saveProxyListToCache();	
	}
	
	this.rebuildProxyMenuList = true;
}

premiumproxyswitcher.saveProxyListToCache = function(){
	var pieces = new Array();
	for(var i in this.proxies){
		var proxy = this.proxies[i];
		pieces.push(proxy.cc+';'+proxy.cn+';'+proxy.server+':'+proxy.port);
	}
	rawProxyList = pieces.join('|');
	
	this.prefManager.setCharPref("extensions.premiumproxyswitcher.proxylist", rawProxyList);
}

premiumproxyswitcher.loadProxyListFromCache = function(){
	var rawProxyList = this.prefManager.getCharPref("extensions.premiumproxyswitcher.proxylist").split('|');
	if (rawProxyList.length > 0)
		for(var i in rawProxyList){
			var rawData = rawProxyList[i].split(';');
			if (rawData.length == 3) {
				var rawProxy = rawData[2].split(':');
				if (rawProxy.length == 2) {
					var proxy = {};
					proxy.cc = rawData[0];
					proxy.cn = rawData[1];
					proxy.server = rawProxy[0];
					proxy.port = rawProxy[1];
					this.proxies.push(proxy);
				}
			}
		}
	this.rebuildProxyMenuList = true;
}

premiumproxyswitcher.switchMode = function(enable){
	this.enabled = enable;
	this.updateStatusBar();
}

premiumproxyswitcher.updateStatusBar=function(){
	if(this.loading){
		this.$('premiumproxyswitcher-status-image').src = "chrome://premiumproxyswitcher/skin/loading_16.gif";
	}else{
		if(this.enabled){
			this.$('premiumproxyswitcher-status-image').src = "chrome://premiumproxyswitcher/skin/enabled.png";
		}else{
			this.$('premiumproxyswitcher-status-image').src = "chrome://premiumproxyswitcher/skin/disabled.png";
		}
	}
	
	if(this.selectedProxy != null){
		this.$('premiumproxyswitcher-status-label').value = this.selectedProxy.server+':'+this.selectedProxy.port;
	} else {
		this.$('premiumproxyswitcher-status-label').value = this.getPropertyString('noProxySpesified');
	}
}

premiumproxyswitcher.$ = function (id){
	return document.getElementById(id);
}

premiumproxyswitcher.switchProxyServer = function(proxy, autochange){
	if(this.proxies.length == 0){
		this.prefManager.setIntPref("network.proxy.type", 0);
		this.setProxyServer();
		this.selectedProxy = null;
		this.switchMode(false);
		return;
	}
	
	if(autochange == null){
		autochange = true;
	}
	
	if(proxy == null){
		proxy = this.proxies[Math.floor(Math.random()*this.proxies.length)];
	}
	
	if(autochange == true || this.selectedProxy == null){
		this.selectedProxy = proxy;
	}
	
	this.rebuildProxyMenuList = true;
	this.setProxyServer(this.selectedProxy.server, this.selectedProxy.port);
	
	this.updateStatusBar();
}

premiumproxyswitcher.setProxyServer = function(server, port){
	if(server == null) {
		server = '';
	}
	if(port == null) {
		port = 0;
	}	
	this.prefManager.setCharPref("network.proxy.http",server);
	this.prefManager.setIntPref("network.proxy.http_port",port);
	this.prefManager.setCharPref("network.proxy.ssl",server);
	this.prefManager.setIntPref("network.proxy.ssl_port",port);
	this.prefManager.setCharPref("network.proxy.ftp",server);
	this.prefManager.setIntPref("network.proxy.ftp_port",port);
	this.prefManager.setCharPref("network.proxy.gopher",server);
	this.prefManager.setIntPref("network.proxy.gopher_port",port);
	this.prefManager.setCharPref("network.proxy.socks",server);
	this.prefManager.setIntPref("network.proxy.socks_port",port);		
}

premiumproxyswitcher.markSelectedDead = function(){
	if(this.proxies.length == 0 || this.selectedProxy == null){
		return;
	}
	
	for(var i =0; i<this.proxies.length; i++){
		if(this.isSameProxy(this.selectedProxy, this.proxies[i])){
			this.proxies.splice(i, 1);
			this.saveProxyListToCache();
			this.rebuildProxyMenuList = true;
			break;
		}
	}
	
	this.switchProxyServer();
}

premiumproxyswitcher.loadProxyServers = function(fromCache){
	fromCache = (fromCache == null) ? false : fromCache;

	if(fromCache) {
		this.fetchProxyList();
	} else {
		var useservice = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optuseservice');
		if(useservice){
			var fields = {cc: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optcountry'),
					  ssl: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optssl'),
					  speed: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optminspeed'),
					  port: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optport'),
					  connect: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optconnect'),
					  ping: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optmaxping'),
					  type: this.prefManager.getCharPref('extensions.premiumproxyswitcher.opttype'),
					  post: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optpostget'),
					  uptime: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optminuptime'),
					  code: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optvip'),
					  interval: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optproxyinterval')};
		
			if(fields.port == 0){
				fields.port == 'any';
			}
		
			if(fields.code.length == 16){
				this.fetchProxyList(this.serviceurl, fields);
			} else {
				alert(this.getPropertyString('noVipPass'));
			}
		}else{
			var userurl = this.prefManager.getCharPref('extensions.premiumproxyswitcher.optcustomizeurl');
			this.fetchProxyList(userurl);
		}
	}
	
}

premiumproxyswitcher.openOptionDialog = function(){
	window.openDialog("chrome://premiumproxyswitcher/content/options.xul", "", null);
}

premiumproxyswitcher.openAboutDialog = function(){
	window.openDialog("chrome://premiumproxyswitcher/content/about.xul", "", null);
}

premiumproxyswitcher.onPopupMenuShown = function(){
	this.$('pps-item-MarkSelectedDead').setAttribute('disabled', (this.selectedProxy == null || !this.enabled));
	this.$('pps-item-SwitchProxyServer').setAttribute('disabled', (this.selectedProxy == null || !this.enabled));
	this.$('pps-item-SelectProxyServer').setAttribute('disabled', (this.proxies.length == 0));
	this.$('pps-item-EnableDisableProxyServer').label = this.getPropertyString((this.enabled) ? 'disableProxyServer' : 'enableProxyServer');
	this.$('pps-item-EnableDisableProxyServer').setAttribute('disabled', (this.selectedProxy == null));	
	
	if(this.rebuildProxyMenuList){
		var menu = this.$('pps-item-SelectProxyServer-popup');
		for(var j=menu.childNodes.length-1;j>=0;j--){
			menu.removeChild(menu.childNodes[j]);
		}
		
		var selectedItem = null;
		var selectedItemIndex = null;
		var i = 0;
		for(i=0;i<this.proxies.length;i++){
			var p = this.proxies[i];
			var isSelected = this.isSameProxy(this.selectedProxy, p);
			//var oItem = menu.appendItem(p.server+':'+p.port, i);
			//var oItem = menu.insertItemAt(0, p.server+':'+p.port, i);
			var oItem = document.createElement('menuitem');
			var oImage = document.createElement('image');
			var oLabel = document.createElement('label');

			oImage.setAttribute("src", "chrome://premiumproxyswitcher/skin/flags/"+((p.cc != '??') ? p.cc+".png" : "unknown.png"));
			oImage.setAttribute("class", "menu-iconic-icon");
			oLabel.setAttribute("value", p.server+':'+p.port);
			oLabel.setAttribute("class", "menu-iconic-text");
			oLabel.setAttribute("flex", "1");
			oLabel.setAttribute("crop", "right");
			
			oItem.innerHTML = p.server+':'+p.port;
			oItem.setAttribute("value", i);
			oItem.setAttribute("label", p.server+':'+p.port);
			oItem.setAttribute("tooltiptext", p.cn);
			oItem.setAttribute("valuehttp", p.server);
			oItem.setAttribute("valuehttpport", p.port);
			oItem.setAttribute("type", "radio");
			oItem.setAttribute("name", "proxieslist");
			oItem.setAttribute("checked", isSelected);
			oItem.setAttribute("class", "proxy-menu-item");
			oItem.appendChild(oImage);
			oItem.appendChild(oLabel);
			
			oItem.setAttribute("oncommand", "premiumproxyswitcher.selectProxy(this);  event.preventBubble();");
			if(isSelected){
				selectedItem = oItem;
				selectedItemIndex = i;
				continue;
			}
			
			menu.appendChild(oItem);
		}
		
		if(selectedItem == null && this.selectedProxy != null){
			var oItem = document.createElement('menuitem');
			var oImage = document.createElement('image');
			var oLabel = document.createElement('label');

			oImage.setAttribute("src", "chrome://premiumproxyswitcher/skin/flags/"+((this.selectedProxy.cc != '??') ? this.selectedProxy.cc+".png" : "unknown.png"));
			oImage.setAttribute("class", "menu-iconic-icon");
			oLabel.setAttribute("value", p.server+':'+p.port);
			oLabel.setAttribute("class", "menu-iconic-text");
			oLabel.setAttribute("flex", "1");
			oLabel.setAttribute("crop", "right");
			
			oItem.innerHTML = this.selectedProxy.server+':'+this.selectedProxy.port;
			oItem.setAttribute("value", i);
			oItem.setAttribute("label", this.selectedProxy.server+':'+this.selectedProxy.port);
			oItem.setAttribute("tooltiptext", this.selectedProxy.cn);
			oItem.setAttribute("valuehttp", this.selectedProxy.server);
			oItem.setAttribute("valuehttpport", this.selectedProxy.port);
			oItem.setAttribute("type", "radio");
			oItem.setAttribute("name", "proxieslist");
			oItem.setAttribute("checked", true);
			oItem.setAttribute("class", "proxy-menu-item");
			oItem.setAttribute("oncommand", "premiumproxyswitcher.selectProxy(this);  event.preventBubble();");
			oItem.appendChild(oImage);
			oItem.appendChild(oLabel);
			
			this.proxies.push(this.selectedProxy);
			menu.appendChild(oItem);
		}else if(selectedItem != null){
			menu.appendChild(selectedItem);
		}
		
		this.rebuildProxyMenuList = false;
	}

}

premiumproxyswitcher.selectProxy=function(comp){
	var i = comp.getAttribute('value');
	
	// manual setup proxy
	this.prefManager.setIntPref("network.proxy.type", 1);
	this.switchMode(true);
	this.switchProxyServer(this.proxies[i]);
}

premiumproxyswitcher.isSameProxy = function(one, another){
	if(one != null && another != null && one.server == another.server && one.port == another.port){
		return true;
	}else{
		return false;
	}
}

window.addEventListener("load", function(e) { premiumproxyswitcher.onLoad(e); }, false);
